-#!/bin/sh
# Tcl ignores the next line -*- tcl -*- \
exec wish "$0" -- "$@"
end]
append title {)}
}
- tk_messageBox \
- -parent . \
+ set cmd [list tk_messageBox \
-icon error \
-type ok \
-title "$title: error" \
- -message $msg
+ -message $msg]
+ if {[winfo ismapped .]} {
+ lappend cmd -parent .
+ }
+ eval $cmd
}
proc info_popup {msg} {
##
## repository setup
-if { [catch {set cdup [exec git rev-parse --show-cdup]} err]
- || [catch {set gitdir [exec git rev-parse --git-dir]} err]} {
+if { [catch {set gitdir $env(GIT_DIR)}]
+ && [catch {set gitdir [exec git rev-parse --git-dir]} err]} {
catch {wm withdraw .}
error_popup "Cannot find the git directory:\n\n$err"
exit 1
}
-if {$cdup ne ""} {
- cd $cdup
+if {![file isdirectory $gitdir]} {
+ catch {wm withdraw .}
+ error_popup "Git directory not found:\n\n$gitdir"
+ exit 1
+}
+if {[lindex [file split $gitdir] end] ne {.git}} {
+ catch {wm withdraw .}
+ error_popup "Cannot use funny .git directory:\n\n$gitdir"
+ exit 1
+}
+if {[catch {cd [file dirname $gitdir]} err]} {
+ catch {wm withdraw .}
+ error_popup "No working directory [file dirname $gitdir]:\n\n$err"
+ exit 1
}
-unset cdup
set single_commit 0
if {$appname eq {git-citool}} {
##
## task management
-set status_active 0
+set rescan_active 0
set diff_active 0
set last_clicked {}
set disable_on_lock [list]
set index_lock_type none
-set HEAD {}
-set PARENT {}
-set commit_type {}
-
proc lock_index {type} {
global index_lock_type disable_on_lock
uplevel #0 $w disabled
}
return 1
- } elseif {$index_lock_type eq {begin-update} && $type eq {update}} {
+ } elseif {$index_lock_type eq "begin-$type"} {
set index_lock_type $type
return 1
}
upvar $hdvar hd $ctvar ct
if {[catch {set hd [exec git rev-parse --verify HEAD]}]} {
+ set hd {}
set ct initial
} elseif {[file exists [file join $gitdir MERGE_HEAD]]} {
set ct merge
}
}
-proc rescan {{final Ready.}} {
+proc PARENT {} {
+ global PARENT empty_tree
+
+ if {$PARENT ne {}} {
+ return $PARENT
+ }
+ if {$empty_tree eq {}} {
+ set empty_tree [exec git mktree << {}]
+ }
+ return $empty_tree
+}
+
+proc rescan {after} {
global HEAD PARENT commit_type
global ui_index ui_other ui_status_value ui_comm
- global status_active file_states
+ global rescan_active file_states
global repo_config
- if {$status_active || ![lock_index read]} return
+ if {$rescan_active > 0 || ![lock_index read]} return
repository_state new_HEAD new_type
- if {$commit_type eq {amend}
+ if {[string match amend* $commit_type]
&& $new_type eq {normal}
&& $new_HEAD eq $HEAD} {
} else {
}
if {$repo_config(gui.trustmtime) eq {true}} {
- rescan_stage2 {} $final
+ rescan_stage2 {} $after
} else {
- set status_active 1
+ set rescan_active 1
set ui_status_value {Refreshing file status...}
set cmd [list git update-index]
lappend cmd -q
set fd_rf [open "| $cmd" r]
fconfigure $fd_rf -blocking 0 -translation binary
fileevent $fd_rf readable \
- [list rescan_stage2 $fd_rf $final]
+ [list rescan_stage2 $fd_rf $after]
}
}
-proc rescan_stage2 {fd final} {
- global gitdir PARENT commit_type
- global ui_index ui_other ui_status_value ui_comm
- global status_active
- global buf_rdi buf_rdf buf_rlo
+proc rescan_stage2 {fd after} {
+ global gitdir ui_status_value
+ global rescan_active buf_rdi buf_rdf buf_rlo
if {$fd ne {}} {
read $fd
set buf_rdf {}
set buf_rlo {}
- set status_active 3
+ set rescan_active 3
set ui_status_value {Scanning for modified files ...}
- set fd_di [open "| git diff-index --cached -z $PARENT" r]
+ set fd_di [open "| git diff-index --cached -z [PARENT]" r]
set fd_df [open "| git diff-files -z" r]
set fd_lo [open $ls_others r]
fconfigure $fd_di -blocking 0 -translation binary
fconfigure $fd_df -blocking 0 -translation binary
fconfigure $fd_lo -blocking 0 -translation binary
- fileevent $fd_di readable [list read_diff_index $fd_di $final]
- fileevent $fd_df readable [list read_diff_files $fd_df $final]
- fileevent $fd_lo readable [list read_ls_others $fd_lo $final]
+ fileevent $fd_di readable [list read_diff_index $fd_di $after]
+ fileevent $fd_df readable [list read_diff_files $fd_df $after]
+ fileevent $fd_lo readable [list read_ls_others $fd_lo $after]
}
proc load_message {file} {
return 0
}
-proc read_diff_index {fd final} {
+proc read_diff_index {fd after} {
global buf_rdi
append buf_rdi [read $fd]
set z2 [string first "\0" $buf_rdi $z1]
if {$z2 == -1} break
- set c $z2
- incr z2 -1
- display_file \
- [string range $buf_rdi $z1 $z2] \
- [string index $buf_rdi [expr {$z1 - 2}]]_
incr c
+ set n [split [string range $buf_rdi $c [expr {$z1 - 2}]] { }]
+ merge_state \
+ [string range $buf_rdi $z1 [expr {$z2 - 1}]] \
+ [lindex $n 4]? \
+ [list [lindex $n 0] [lindex $n 2]] \
+ [list]
+ set c $z2
}
if {$c < $n} {
set buf_rdi [string range $buf_rdi $c end]
set buf_rdi {}
}
- status_eof $fd buf_rdi $final
+ rescan_done $fd buf_rdi $after
}
-proc read_diff_files {fd final} {
+proc read_diff_files {fd after} {
global buf_rdf
append buf_rdf [read $fd]
set z2 [string first "\0" $buf_rdf $z1]
if {$z2 == -1} break
- set c $z2
- incr z2 -1
- display_file \
- [string range $buf_rdf $z1 $z2] \
- _[string index $buf_rdf [expr {$z1 - 2}]]
incr c
+ set n [split [string range $buf_rdf $c [expr {$z1 - 2}]] { }]
+ merge_state \
+ [string range $buf_rdf $z1 [expr {$z2 - 1}]] \
+ ?[lindex $n 4] \
+ [list] \
+ [list [lindex $n 0] [lindex $n 2]]
+ set c $z2
}
if {$c < $n} {
set buf_rdf [string range $buf_rdf $c end]
set buf_rdf {}
}
- status_eof $fd buf_rdf $final
+ rescan_done $fd buf_rdf $after
}
-proc read_ls_others {fd final} {
+proc read_ls_others {fd after} {
global buf_rlo
append buf_rlo [read $fd]
set pck [split $buf_rlo "\0"]
set buf_rlo [lindex $pck end]
foreach p [lrange $pck 0 end-1] {
- display_file $p _O
+ merge_state $p ?O
}
- status_eof $fd buf_rlo $final
+ rescan_done $fd buf_rlo $after
}
-proc status_eof {fd buf final} {
- global status_active ui_status_value
+proc rescan_done {fd buf after} {
+ global rescan_active
global file_states repo_config
upvar $buf to_clear
if {![eof $fd]} return
set to_clear {}
close $fd
- if {[incr status_active -1] > 0} return
+ if {[incr rescan_active -1] > 0} return
prune_selection
unlock_index
display_all_files
if {$repo_config(gui.partialinclude) ne {true}} {
- set pathList [list]
+ set pathList [list]
foreach path [array names file_states] {
switch -- [lindex $file_states($path) 0] {
AM -
}
}
if {$pathList ne {}} {
- update_index $pathList
+ update_index \
+ "Updating included files" \
+ $pathList \
+ [concat {reshow_diff;} $after]
return
}
}
reshow_diff
- set ui_status_value $final
+ uplevel #0 $after
}
proc prune_selection {} {
## diff
proc clear_diff {} {
- global ui_diff ui_fname_value ui_fstatus_value ui_index ui_other
+ global ui_diff current_diff ui_index ui_other
$ui_diff conf -state normal
$ui_diff delete 0.0 end
$ui_diff conf -state disabled
- set ui_fname_value {}
- set ui_fstatus_value {}
+ set current_diff {}
$ui_index tag remove in_diff 0.0 end
$ui_other tag remove in_diff 0.0 end
}
proc reshow_diff {} {
- global ui_fname_value ui_status_value file_states
+ global current_diff ui_status_value file_states
- if {$ui_fname_value eq {}
- || [catch {set s $file_states($ui_fname_value)}]} {
+ if {$current_diff eq {}
+ || [catch {set s $file_states($current_diff)}]} {
clear_diff
} else {
- show_diff $ui_fname_value
+ show_diff $current_diff
}
}
proc handle_empty_diff {} {
- global ui_fname_value file_states file_lists
+ global current_diff file_states file_lists
- set path $ui_fname_value
+ set path $current_diff
set s $file_states($path)
if {[lindex $s 0] ne {_M}} return
proc show_diff {path {w {}} {lno {}}} {
global file_states file_lists
- global PARENT diff_3way diff_active repo_config
- global ui_diff ui_fname_value ui_fstatus_value ui_status_value
+ global diff_3way diff_active repo_config
+ global ui_diff current_diff ui_status_value
if {$diff_active || ![lock_index read]} return
set m [lindex $s 0]
set diff_3way 0
set diff_active 1
- set ui_fname_value $path
- set ui_fstatus_value [mapdesc $m $path]
+ set current_diff $path
set ui_status_value "Loading diff of [escape_path $path]..."
set cmd [list | git diff-index]
}
}
- lappend cmd $PARENT
+ lappend cmd [PARENT]
lappend cmd --
lappend cmd $path
proc load_last_commit {} {
global HEAD PARENT commit_type ui_comm
- if {$commit_type eq {amend}} return
+ if {[string match amend* $commit_type]} return
if {$commit_type ne {normal}} {
error_popup "Can't amend a $commit_type commit."
return
return
}
+ if {$parent_count > 1} {
+ error_popup {Can't amend a merge commit.}
+ return
+ }
+
if {$parent_count == 0} {
- set commit_type amend
- set HEAD {}
+ set commit_type amend-initial
set PARENT {}
- rescan
} elseif {$parent_count == 1} {
set commit_type amend
set PARENT $parent
- $ui_comm delete 0.0 end
- $ui_comm insert end $msg
- $ui_comm edit modified false
- $ui_comm edit reset
- rescan
- } else {
- error_popup {You can't amend a merge commit.}
- return
}
+
+ $ui_comm delete 0.0 end
+ $ui_comm insert end $msg
+ $ui_comm edit modified false
+ $ui_comm edit reset
+ rescan {set ui_status_value {Ready.}}
+}
+
+proc create_new_commit {} {
+ global commit_type ui_comm
+
+ set commit_type normal
+ $ui_comm delete 0.0 end
+ $ui_comm edit modified false
+ $ui_comm edit reset
+ rescan {set ui_status_value {Ready.}}
+}
+
+set GIT_COMMITTER_IDENT {}
+
+proc committer_ident {} {
+ global GIT_COMMITTER_IDENT
+
+ if {$GIT_COMMITTER_IDENT eq {}} {
+ if {[catch {set me [exec git var GIT_COMMITTER_IDENT]} err]} {
+ error_popup "Unable to obtain your identity:\n\n$err"
+ return {}
+ }
+ if {![regexp {^(.*) [0-9]+ [-+0-9]+$} \
+ $me me GIT_COMMITTER_IDENT]} {
+ error_popup "Invalid GIT_COMMITTER_IDENT:\n\n$me"
+ return {}
+ }
+ }
+
+ return $GIT_COMMITTER_IDENT
}
proc commit_tree {} {
- global tcl_platform HEAD gitdir commit_type file_states
- global pch_error
- global ui_status_value ui_comm
+ global HEAD commit_type file_states ui_comm repo_config
if {![lock_index update]} return
+ if {[committer_ident] eq {}} return
# -- Our in memory state should match the repository.
#
repository_state curHEAD cur_type
- if {$commit_type eq {amend}
+ if {[string match amend* $commit_type]
&& $cur_type eq {normal}
&& $curHEAD eq $HEAD} {
} elseif {$commit_type ne $cur_type || $HEAD ne $curHEAD} {
- error_popup {Last scanned state does not match repository state.
+ info_popup {Last scanned state does not match repository state.
-Its highly likely that another Git program modified the
-repository since our last scan. A rescan is required
-before committing.
+Another Git program has modified this repository
+since the last scan. A rescan must be performed
+before another commit can be created.
+
+The rescan will be automatically started now.
}
unlock_index
- rescan
+ rescan {set ui_status_value {Ready.}}
return
}
#
set files_ready 0
foreach path [array names file_states] {
- set s $file_states($path)
- switch -glob -- [lindex $s 0] {
+ switch -glob -- [lindex $file_states($path) 0] {
_? {continue}
A? -
D? -
return
}
- # -- Ask the pre-commit hook for the go-ahead.
+ # -- Update included files if partialincludes are off.
#
+ if {$repo_config(gui.partialinclude) ne {true}} {
+ set pathList [list]
+ foreach path [array names file_states] {
+ switch -glob -- [lindex $file_states($path) 0] {
+ A? -
+ M? {lappend pathList $path}
+ }
+ }
+ if {$pathList ne {}} {
+ unlock_index
+ update_index \
+ "Updating included files" \
+ $pathList \
+ [concat {lock_index update;} \
+ [list commit_prehook $curHEAD $msg]]
+ return
+ }
+ }
+
+ commit_prehook $curHEAD $msg
+}
+
+proc commit_prehook {curHEAD msg} {
+ global tcl_platform gitdir ui_status_value pch_error
+
+ # On Cygwin [file executable] might lie so we need to ask
+ # the shell if the hook is executable. Yes that's annoying.
+
set pchook [file join $gitdir hooks pre-commit]
- if {$tcl_platform(platform) eq {windows} && [file isfile $pchook]} {
+ if {$tcl_platform(platform) eq {windows}
+ && [file isfile $pchook]} {
set pchook [list sh -c [concat \
"if test -x \"$pchook\";" \
"then exec \"$pchook\" 2>&1;" \
} elseif {[file executable $pchook]} {
set pchook [list $pchook |& cat]
} else {
- set pchook {}
- }
- if {$pchook ne {}} {
- set ui_status_value {Calling pre-commit hook...}
- set pch_error {}
- set fd_ph [open "| $pchook" r]
- fconfigure $fd_ph -blocking 0 -translation binary
- fileevent $fd_ph readable \
- [list commit_stage1 $fd_ph $curHEAD $msg]
- } else {
- commit_stage2 $curHEAD $msg
+ commit_writetree $curHEAD $msg
+ return
}
+
+ set ui_status_value {Calling pre-commit hook...}
+ set pch_error {}
+ set fd_ph [open "| $pchook" r]
+ fconfigure $fd_ph -blocking 0 -translation binary
+ fileevent $fd_ph readable \
+ [list commit_prehook_wait $fd_ph $curHEAD $msg]
}
-proc commit_stage1 {fd_ph curHEAD msg} {
+proc commit_prehook_wait {fd_ph curHEAD msg} {
global pch_error ui_status_value
append pch_error [read $fd_ph]
hook_failed_popup pre-commit $pch_error
unlock_index
} else {
- commit_stage2 $curHEAD $msg
+ commit_writetree $curHEAD $msg
}
set pch_error {}
- } else {
- fconfigure $fd_ph -blocking 0
+ return
}
+ fconfigure $fd_ph -blocking 0
}
-proc commit_stage2 {curHEAD msg} {
+proc commit_writetree {curHEAD msg} {
global ui_status_value
- # -- Write the tree in the background.
- #
set ui_status_value {Committing changes...}
set fd_wt [open "| git write-tree" r]
- fileevent $fd_wt readable [list commit_stage3 $fd_wt $curHEAD $msg]
+ fileevent $fd_wt readable \
+ [list commit_committree $fd_wt $curHEAD $msg]
}
-proc commit_stage3 {fd_wt curHEAD msg} {
+proc commit_committree {fd_wt curHEAD msg} {
global single_commit gitdir HEAD PARENT commit_type tcl_platform
- global ui_status_value ui_comm
+ global ui_status_value ui_comm selected_commit_type
global file_states selected_paths
gets $fd_wt tree_id
# -- Update status without invoking any git commands.
#
set commit_type normal
+ set selected_commit_type new
set HEAD $cmt_id
set PARENT $cmt_id
before a pull can be started.
}
unlock_index
- rescan
+ rescan {set ui_status_value {Ready.}}
return
}
}
proc post_pull_remote {remote branch success} {
- global HEAD PARENT commit_type
+ global HEAD PARENT commit_type selected_commit_type
global ui_status_value
unlock_index
if {$success} {
repository_state HEAD commit_type
set PARENT $HEAD
- set $ui_status_value {Ready.}
+ set selected_commit_type new
+ set $ui_status_value "Pulling $branch from $remote complete."
} else {
- rescan \
- "Conflicts detected while pulling $branch from $remote."
+ set m "Conflicts detected while pulling $branch from $remote."
+ rescan "set ui_status_value {$m}"
}
}
set next_icon_id 0
-proc merge_state {path new_state} {
+proc merge_state {path new_state {head_info {}} {index_info {}}} {
global file_states next_icon_id
set s0 [string index $new_state 0]
} else {
set state [lindex $info 0]
set icon [lindex $info 1]
+ if {$head_info eq {}} {set head_info [lindex $info 2]}
+ if {$index_info eq {}} {set index_info [lindex $info 3]}
}
- if {$s0 eq {_}} {
- set s0 [string index $state 0]
- } elseif {$s0 eq {*}} {
- set s0 _
- }
+ if {$s0 eq {?}} {set s0 [string index $state 0]} \
+ elseif {$s0 eq {_}} {set s0 _}
+
+ if {$s1 eq {?}} {set s1 [string index $state 1]} \
+ elseif {$s1 eq {_}} {set s1 _}
- if {$s1 eq {_}} {
- set s1 [string index $state 1]
- } elseif {$s1 eq {*}} {
- set s1 _
+ if {$s0 ne {_} && [string index $state 0] eq {_}
+ && $head_info eq {}} {
+ set head_info $index_info
}
- set file_states($path) [list $s0$s1 $icon]
+ set file_states($path) [list $s0$s1 $icon \
+ $head_info $index_info \
+ ]
return $state
}
proc display_file {path state} {
- global file_states file_lists selected_paths status_active
+ global file_states file_lists selected_paths
set old_m [merge_state $path $state]
- if {$status_active} return
-
set s $file_states($path)
set new_m [lindex $s 0]
set new_w [mapcol $new_m $path]
$ui_other conf -state disabled
}
-proc update_index {pathList} {
- global update_index_cp update_index_rsd ui_status_value
+proc update_indexinfo {msg pathList after} {
+ global update_index_cp ui_status_value
+
+ if {![lock_index update]} return
+
+ set update_index_cp 0
+ set pathList [lsort $pathList]
+ set totalCnt [llength $pathList]
+ set batch [expr {int($totalCnt * .01) + 1}]
+ if {$batch > 25} {set batch 25}
+
+ set ui_status_value [format \
+ "$msg... %i/%i files (%.2f%%)" \
+ $update_index_cp \
+ $totalCnt \
+ 0.0]
+ set fd [open "| git update-index -z --index-info" w]
+ fconfigure $fd \
+ -blocking 0 \
+ -buffering full \
+ -buffersize 512 \
+ -translation binary
+ fileevent $fd writable [list \
+ write_update_indexinfo \
+ $fd \
+ $pathList \
+ $totalCnt \
+ $batch \
+ $msg \
+ $after \
+ ]
+}
+
+proc write_update_indexinfo {fd pathList totalCnt batch msg after} {
+ global update_index_cp ui_status_value
+ global file_states current_diff
+
+ if {$update_index_cp >= $totalCnt} {
+ close $fd
+ unlock_index
+ uplevel #0 $after
+ return
+ }
+
+ for {set i $batch} \
+ {$update_index_cp < $totalCnt && $i > 0} \
+ {incr i -1} {
+ set path [lindex $pathList $update_index_cp]
+ incr update_index_cp
+
+ set s $file_states($path)
+ switch -glob -- [lindex $s 0] {
+ A? {set new _O}
+ M? {set new _M}
+ D? {set new _?}
+ ?? {continue}
+ }
+ set info [lindex $s 2]
+ if {$info eq {}} continue
+
+ puts -nonewline $fd $info
+ puts -nonewline $fd "\t"
+ puts -nonewline $fd $path
+ puts -nonewline $fd "\0"
+ display_file $path $new
+ }
+
+ set ui_status_value [format \
+ "$msg... %i/%i files (%.2f%%)" \
+ $update_index_cp \
+ $totalCnt \
+ [expr {100.0 * $update_index_cp / $totalCnt}]]
+}
+
+proc update_index {msg pathList after} {
+ global update_index_cp ui_status_value
if {![lock_index update]} return
set update_index_cp 0
- set update_index_rsd 0
set pathList [lsort $pathList]
set totalCnt [llength $pathList]
set batch [expr {int($totalCnt * .01) + 1}]
if {$batch > 25} {set batch 25}
set ui_status_value [format \
- "Including files ... %i/%i files (%.2f%%)" \
+ "$msg... %i/%i files (%.2f%%)" \
$update_index_cp \
$totalCnt \
0.0]
$pathList \
$totalCnt \
$batch \
+ $msg \
+ $after \
]
}
-proc write_update_index {fd pathList totalCnt batch} {
- global update_index_cp update_index_rsd ui_status_value
- global file_states ui_fname_value
+proc write_update_index {fd pathList totalCnt batch msg after} {
+ global update_index_cp ui_status_value
+ global file_states current_diff
if {$update_index_cp >= $totalCnt} {
close $fd
unlock_index
- set ui_status_value {Ready.}
- if {$update_index_rsd} {
- reshow_diff
- }
+ uplevel #0 $after
return
}
set path [lindex $pathList $update_index_cp]
incr update_index_cp
- switch -- [lindex $file_states($path) 0] {
- AM -
- _O {set new A*}
- _M -
- MM {set new M*}
+ switch -glob -- [lindex $file_states($path) 0] {
AD -
- _D {set new D*}
- default {continue}
+ MD -
+ _D {set new D_}
+
+ _M -
+ MM -
+ M_ {set new M_}
+
+ _O -
+ AM -
+ A_ {set new A_}
+
+ ?? {continue}
}
puts -nonewline $fd $path
puts -nonewline $fd "\0"
display_file $path $new
- if {$ui_fname_value eq $path} {
- set update_index_rsd 1
- }
}
set ui_status_value [format \
- "Including files ... %i/%i files (%.2f%%)" \
+ "$msg... %i/%i files (%.2f%%)" \
$update_index_cp \
$totalCnt \
[expr {100.0 * $update_index_cp / $totalCnt}]]
set all_remotes [lsort -unique $all_remotes]
}
-proc populate_remote_menu {m pfx op} {
- global all_remotes
+proc populate_fetch_menu {m} {
+ global gitdir all_remotes repo_config
- foreach remote $all_remotes {
- $m add command -label "$pfx $remote..." \
- -command [list $op $remote] \
- -font font_ui
+ foreach r $all_remotes {
+ set enable 0
+ if {![catch {set a $repo_config(remote.$r.url)}]} {
+ if {![catch {set a $repo_config(remote.$r.fetch)}]} {
+ set enable 1
+ }
+ } else {
+ catch {
+ set fd [open [file join $gitdir remotes $r] r]
+ while {[gets $fd n] >= 0} {
+ if {[regexp {^Pull:[ \t]*([^:]+):} $n]} {
+ set enable 1
+ break
+ }
+ }
+ close $fd
+ }
+ }
+
+ if {$enable} {
+ $m add command \
+ -label "Fetch from $r..." \
+ -command [list fetch_from $r] \
+ -font font_ui
+ }
+ }
+}
+
+proc populate_push_menu {m} {
+ global gitdir all_remotes repo_config
+
+ foreach r $all_remotes {
+ set enable 0
+ if {![catch {set a $repo_config(remote.$r.url)}]} {
+ if {![catch {set a $repo_config(remote.$r.push)}]} {
+ set enable 1
+ }
+ } else {
+ catch {
+ set fd [open [file join $gitdir remotes $r] r]
+ while {[gets $fd n] >= 0} {
+ if {[regexp {^Push:[ \t]*([^:]+):} $n]} {
+ set enable 1
+ break
+ }
+ }
+ close $fd
+ }
+ }
+
+ if {$enable} {
+ $m add command \
+ -label "Push to $r..." \
+ -command [list push_to $r] \
+ -font font_ui
+ }
}
}
}
proc do_rescan {} {
- rescan
+ rescan {set ui_status_value {Ready.}}
}
-proc do_include_all {} {
- global file_states
+proc remove_helper {txt paths} {
+ global file_states current_diff
if {![lock_index begin-update]} return
set pathList [list]
- foreach path [array names file_states] {
- set s $file_states($path)
- set m [lindex $s 0]
- switch -- $m {
+ set after {}
+ foreach path $paths {
+ switch -glob -- [lindex $file_states($path) 0] {
+ A? -
+ M? -
+ D? {
+ lappend pathList $path
+ if {$path eq $current_diff} {
+ set after {reshow_diff;}
+ }
+ }
+ }
+ }
+ if {$pathList eq {}} {
+ unlock_index
+ } else {
+ update_indexinfo \
+ $txt \
+ $pathList \
+ [concat $after {set ui_status_value {Ready.}}]
+ }
+}
+
+proc do_remove_selection {} {
+ global current_diff selected_paths
+
+ if {[array size selected_paths] > 0} {
+ remove_helper \
+ {Removing selected files from commit} \
+ [array names selected_paths]
+ } elseif {$current_diff ne {}} {
+ remove_helper \
+ "Removing [short_path $current_diff] from commit" \
+ [list $current_diff]
+ }
+}
+
+proc include_helper {txt paths} {
+ global file_states current_diff
+
+ if {![lock_index begin-update]} return
+
+ set pathList [list]
+ set after {}
+ foreach path $paths {
+ switch -- [lindex $file_states($path) 0] {
AM -
+ AD -
MM -
+ UM -
+ U_ -
_M -
- _D {lappend pathList $path}
+ _D -
+ _O {
+ lappend pathList $path
+ if {$path eq $current_diff} {
+ set after {reshow_diff;}
+ }
+ }
}
}
if {$pathList eq {}} {
unlock_index
} else {
- update_index $pathList
+ update_index \
+ $txt \
+ $pathList \
+ [concat $after {set ui_status_value {Ready to commit.}}]
}
}
-set GIT_COMMITTER_IDENT {}
+proc do_include_selection {} {
+ global current_diff selected_paths
-proc do_signoff {} {
- global ui_comm GIT_COMMITTER_IDENT
+ if {[array size selected_paths] > 0} {
+ include_helper \
+ {Including selected files} \
+ [array names selected_paths]
+ } elseif {$current_diff ne {}} {
+ include_helper \
+ "Including [short_path $current_diff]" \
+ [list $current_diff]
+ }
+}
- if {$GIT_COMMITTER_IDENT eq {}} {
- if {[catch {set me [exec git var GIT_COMMITTER_IDENT]} err]} {
- error_popup "Unable to obtain your identity:\n\n$err"
- return
- }
- if {![regexp {^(.*) [0-9]+ [-+0-9]+$} \
- $me me GIT_COMMITTER_IDENT]} {
- error_popup "Invalid GIT_COMMITTER_IDENT:\n\n$me"
- return
+proc do_include_all {} {
+ global file_states
+
+ set paths [list]
+ foreach path [array names file_states] {
+ switch -- [lindex $file_states($path) 0] {
+ AM -
+ AD -
+ MM -
+ _M -
+ _D {lappend paths $path}
}
}
+ include_helper \
+ {Including all modified files} \
+ $paths
+}
- set sob "Signed-off-by: $GIT_COMMITTER_IDENT"
+proc do_signoff {} {
+ global ui_comm
+
+ set me [committer_ident]
+ if {$me eq {}} return
+
+ set sob "Signed-off-by: $me"
set last [$ui_comm get {end -1c linestart} {end -1c}]
if {$last ne $sob} {
$ui_comm edit separator
}
}
-proc do_amend_last {} {
- load_last_commit
+proc do_select_commit_type {} {
+ global commit_type selected_commit_type
+
+ if {$selected_commit_type eq {new}
+ && [string match amend* $commit_type]} {
+ create_new_commit
+ } elseif {$selected_commit_type eq {amend}
+ && ![string match amend* $commit_type]} {
+ load_last_commit
+
+ # The amend request was rejected...
+ #
+ if {![string match amend* $commit_type]} {
+ set selected_commit_type new
+ }
+ }
}
proc do_commit {} {
destroy $w
}
+proc do_windows_shortcut {} {
+ global gitdir appname argv0
+
+ set reponame [lindex [file split \
+ [file normalize [file dirname $gitdir]]] \
+ end]
+
+ if {[catch {
+ set desktop [exec cygpath \
+ --windows \
+ --absolute \
+ --long-name \
+ --desktop]
+ }]} {
+ set desktop .
+ }
+ set fn [tk_getSaveFile \
+ -parent . \
+ -title "$appname ($reponame): Create Desktop Icon" \
+ -initialdir $desktop \
+ -initialfile "Git $reponame.bat"]
+ if {$fn != {}} {
+ if {[catch {
+ set fd [open $fn w]
+ set sh [exec cygpath \
+ --windows \
+ --absolute \
+ --long-name \
+ /bin/sh]
+ set me [exec cygpath \
+ --unix \
+ --absolute \
+ $argv0]
+ set gd [exec cygpath \
+ --unix \
+ --absolute \
+ $gitdir]
+ regsub -all ' $me "'\\''" me
+ regsub -all ' $gd "'\\''" gd
+ puts -nonewline $fd "\"$sh\" --login -c \""
+ puts -nonewline $fd "GIT_DIR='$gd'"
+ puts -nonewline $fd " '$me'"
+ puts $fd "&\""
+ close $fd
+ } err]} {
+ error_popup "Cannot write script:\n\n$err"
+ }
+ }
+}
+
+proc do_macosx_app {} {
+ global gitdir appname argv0 env
+
+ set reponame [lindex [file split \
+ [file normalize [file dirname $gitdir]]] \
+ end]
+
+ set fn [tk_getSaveFile \
+ -parent . \
+ -title "$appname ($reponame): Create Desktop Icon" \
+ -initialdir [file join $env(HOME) Desktop] \
+ -initialfile "Git $reponame.app"]
+ if {$fn != {}} {
+ if {[catch {
+ set Contents [file join $fn Contents]
+ set MacOS [file join $Contents MacOS]
+ set exe [file join $MacOS git-gui]
+
+ file mkdir $MacOS
+
+ set fd [open [file join $Contents Info.plist] w]
+ puts $fd {<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+ <key>CFBundleDevelopmentRegion</key>
+ <string>English</string>
+ <key>CFBundleExecutable</key>
+ <string>git-gui</string>
+ <key>CFBundleIdentifier</key>
+ <string>org.spearce.git-gui</string>
+ <key>CFBundleInfoDictionaryVersion</key>
+ <string>6.0</string>
+ <key>CFBundlePackageType</key>
+ <string>APPL</string>
+ <key>CFBundleSignature</key>
+ <string>????</string>
+ <key>CFBundleVersion</key>
+ <string>1.0</string>
+ <key>NSPrincipalClass</key>
+ <string>NSApplication</string>
+</dict>
+</plist>}
+ close $fd
+
+ set fd [open $exe w]
+ set gd [file normalize $gitdir]
+ set ep [file normalize [exec git --exec-path]]
+ regsub -all ' $gd "'\\''" gd
+ regsub -all ' $ep "'\\''" ep
+ puts $fd "#!/bin/sh"
+ foreach name [array names env] {
+ if {[string match GIT_* $name]} {
+ regsub -all ' $env($name) "'\\''" v
+ puts $fd "export $name='$v'"
+ }
+ }
+ puts $fd "export PATH='$ep':\$PATH"
+ puts $fd "export GIT_DIR='$gd'"
+ puts $fd "exec [file normalize $argv0]"
+ close $fd
+
+ file attributes $exe -permissions u+x,g+x,o+x
+ } err]} {
+ error_popup "Cannot write icon:\n\n$err"
+ }
+ }
+}
+
proc toggle_or_diff {w x y} {
- global file_lists ui_index ui_other
+ global file_states file_lists current_diff ui_index ui_other
global last_clicked selected_paths
set pos [split [$w index @$x,$y] .]
$ui_other tag remove in_sel 0.0 end
if {$col == 0} {
- update_index [list $path]
+ if {$current_diff eq $path} {
+ set after {reshow_diff;}
+ } else {
+ set after {}
+ }
+ switch -glob -- [lindex $file_states($path) 0] {
+ A_ -
+ AO -
+ M_ -
+ D_ {
+ update_indexinfo \
+ "Removing [short_path $path] from commit" \
+ [list $path] \
+ [concat $after {set ui_status_value {Ready.}}]
+ }
+ ?? {
+ update_index \
+ "Including [short_path $path]" \
+ [list $path] \
+ [concat $after {set ui_status_value {Ready.}}]
+ }
+ }
} else {
show_diff $path $w $lno
}
## ui construction
# -- Menu Bar
+#
menu .mbar -tearoff 0
.mbar add cascade -label Project -menu .mbar.project
.mbar add cascade -label Edit -menu .mbar.edit
. configure -menu .mbar
# -- Project Menu
+#
menu .mbar.project
.mbar.project add command -label Visualize \
-command do_gitk \
.mbar.project add command -label {Repack Database} \
-command do_repack \
-font font_ui
+
+ if {$tcl_platform(platform) eq {windows}} {
+ .mbar.project add command \
+ -label {Create Desktop Icon} \
+ -command do_windows_shortcut \
+ -font font_ui
+ } elseif {[is_MacOSX]} {
+ .mbar.project add command \
+ -label {Create Desktop Icon} \
+ -command do_macosx_app \
+ -font font_ui
+ }
}
.mbar.project add command -label Quit \
-command do_quit \
-font font_ui
# -- Commit Menu
+#
menu .mbar.commit
+
+.mbar.commit add radiobutton \
+ -label {New Commit} \
+ -command do_select_commit_type \
+ -variable selected_commit_type \
+ -value new \
+ -font font_ui
+lappend disable_on_lock \
+ [list .mbar.commit entryconf [.mbar.commit index last] -state]
+
+.mbar.commit add radiobutton \
+ -label {Amend Last Commit} \
+ -command do_select_commit_type \
+ -variable selected_commit_type \
+ -value amend \
+ -font font_ui
+lappend disable_on_lock \
+ [list .mbar.commit entryconf [.mbar.commit index last] -state]
+
+.mbar.commit add separator
+
.mbar.commit add command -label Rescan \
-command do_rescan \
-accelerator F5 \
-font font_ui
lappend disable_on_lock \
[list .mbar.commit entryconf [.mbar.commit index last] -state]
-.mbar.commit add command -label {Amend Last Commit} \
- -command do_amend_last \
+
+.mbar.commit add command -label {Remove From Commit} \
+ -command do_remove_selection \
+ -font font_ui
+lappend disable_on_lock \
+ [list .mbar.commit entryconf [.mbar.commit index last] -state]
+
+.mbar.commit add command -label {Include In Commit} \
+ -command do_include_selection \
-font font_ui
lappend disable_on_lock \
[list .mbar.commit entryconf [.mbar.commit index last] -state]
-.mbar.commit add command -label {Include All Files} \
+
+.mbar.commit add command -label {Include All} \
-command do_include_all \
-accelerator $M1T-I \
-font font_ui
lappend disable_on_lock \
[list .mbar.commit entryconf [.mbar.commit index last] -state]
+
+.mbar.commit add separator
+
.mbar.commit add command -label {Sign Off} \
-command do_signoff \
-accelerator $M1T-S \
-font font_ui
+
.mbar.commit add command -label Commit \
-command do_commit \
-accelerator $M1T-Return \
lappend disable_on_lock \
[list .mbar.commit entryconf [.mbar.commit index last] -state]
+# -- Transport menus
+#
if {!$single_commit} {
- # -- Fetch Menu
menu .mbar.fetch
-
- # -- Pull Menu
menu .mbar.pull
-
- # -- Push Menu
menu .mbar.push
}
# -- Main Window Layout
+#
panedwindow .vpane -orient vertical
panedwindow .vpane.files -orient horizontal
.vpane add .vpane.files -sticky nsew -height 100 -width 400
pack .vpane -anchor n -side top -fill both -expand 1
# -- Index File List
+#
frame .vpane.files.index -height 100 -width 400
label .vpane.files.index.title -text {Modified Files} \
-background green \
.vpane.files add .vpane.files.index -sticky nsew
# -- Other (Add) File List
+#
frame .vpane.files.other -height 100 -width 100
label .vpane.files.other.title -text {Untracked Files} \
-background red \
unset i
# -- Diff and Commit Area
+#
frame .vpane.lower -height 300 -width 400
frame .vpane.lower.commarea
frame .vpane.lower.diff -relief sunken -borderwidth 1
.vpane add .vpane.lower -stick nsew
# -- Commit Area Buttons
+#
frame .vpane.lower.commarea.buttons
label .vpane.lower.commarea.buttons.l -text {} \
-anchor w \
lappend disable_on_lock \
{.vpane.lower.commarea.buttons.rescan conf -state}
-button .vpane.lower.commarea.buttons.amend -text {Amend Last} \
- -command do_amend_last \
- -font font_ui
-pack .vpane.lower.commarea.buttons.amend -side top -fill x
-lappend disable_on_lock \
- {.vpane.lower.commarea.buttons.amend conf -state}
-
button .vpane.lower.commarea.buttons.incall -text {Include All} \
-command do_include_all \
-font font_ui
{.vpane.lower.commarea.buttons.commit conf -state}
# -- Commit Message Buffer
+#
frame .vpane.lower.commarea.buffer
+frame .vpane.lower.commarea.buffer.header
set ui_comm .vpane.lower.commarea.buffer.t
-set ui_coml .vpane.lower.commarea.buffer.l
-label $ui_coml -text {Commit Message:} \
+set ui_coml .vpane.lower.commarea.buffer.header.l
+radiobutton .vpane.lower.commarea.buffer.header.new \
+ -text {New Commit} \
+ -command do_select_commit_type \
+ -variable selected_commit_type \
+ -value new \
+ -font font_ui
+lappend disable_on_lock \
+ [list .vpane.lower.commarea.buffer.header.new conf -state]
+radiobutton .vpane.lower.commarea.buffer.header.amend \
+ -text {Amend Last Commit} \
+ -command do_select_commit_type \
+ -variable selected_commit_type \
+ -value amend \
+ -font font_ui
+lappend disable_on_lock \
+ [list .vpane.lower.commarea.buffer.header.amend conf -state]
+label $ui_coml \
-anchor w \
-justify left \
-font font_ui
-trace add variable commit_type write {uplevel #0 {
- switch -glob $commit_type \
- initial {$ui_coml conf -text {Initial Commit Message:}} \
- amend {$ui_coml conf -text {Amended Commit Message:}} \
- merge {$ui_coml conf -text {Merge Commit Message:}} \
- * {$ui_coml conf -text {Commit Message:}}
-}}
+proc trace_commit_type {varname args} {
+ global ui_coml commit_type
+ switch -glob -- $commit_type {
+ initial {set txt {Initial Commit Message:}}
+ amend {set txt {Amended Commit Message:}}
+ amend-initial {set txt {Amended Initial Commit Message:}}
+ merge {set txt {Merge Commit Message:}}
+ * {set txt {Commit Message:}}
+ }
+ $ui_coml conf -text $txt
+}
+trace add variable commit_type write trace_commit_type
+pack $ui_coml -side left -fill x
+pack .vpane.lower.commarea.buffer.header.amend -side right
+pack .vpane.lower.commarea.buffer.header.new -side right
+
text $ui_comm -background white -borderwidth 1 \
-undo true \
-maxundo 20 \
-yscrollcommand {.vpane.lower.commarea.buffer.sby set}
scrollbar .vpane.lower.commarea.buffer.sby \
-command [list $ui_comm yview]
-pack $ui_coml -side top -fill x
+pack .vpane.lower.commarea.buffer.header -side top -fill x
pack .vpane.lower.commarea.buffer.sby -side right -fill y
pack $ui_comm -side left -fill y
pack .vpane.lower.commarea.buffer -side left -fill y
# -- Commit Message Buffer Context Menu
#
-menu $ui_comm.ctxm -tearoff 0
-$ui_comm.ctxm add command -label "Cut" \
+set ctxm .vpane.lower.commarea.buffer.ctxm
+menu $ctxm -tearoff 0
+$ctxm add command \
+ -label {Cut} \
-font font_ui \
- -command "tk_textCut $ui_comm"
-$ui_comm.ctxm add command -label "Copy" \
+ -command {tk_textCut $ui_comm}
+$ctxm add command \
+ -label {Copy} \
-font font_ui \
- -command "tk_textCopy $ui_comm"
-$ui_comm.ctxm add command -label "Paste" \
+ -command {tk_textCopy $ui_comm}
+$ctxm add command \
+ -label {Paste} \
-font font_ui \
- -command "tk_textPaste $ui_comm"
-$ui_comm.ctxm add command -label "Delete" \
+ -command {tk_textPaste $ui_comm}
+$ctxm add command \
+ -label {Delete} \
-font font_ui \
- -command "$ui_comm delete sel.first sel.last"
-$ui_comm.ctxm add separator
-$ui_comm.ctxm add command -label "Select All" \
+ -command {$ui_comm delete sel.first sel.last}
+$ctxm add separator
+$ctxm add command \
+ -label {Select All} \
-font font_ui \
- -command "$ui_comm tag add sel 0.0 end"
-$ui_comm.ctxm add command -label "Copy All" \
+ -command {$ui_comm tag add sel 0.0 end}
+$ctxm add command \
+ -label {Copy All} \
-font font_ui \
- -command "
+ -command {
$ui_comm tag add sel 0.0 end
tk_textCopy $ui_comm
$ui_comm tag remove sel 0.0 end
- "
-$ui_comm.ctxm add separator
-$ui_comm.ctxm add command -label "Sign Off" \
+ }
+$ctxm add separator
+$ctxm add command \
+ -label {Sign Off} \
-font font_ui \
-command do_signoff
-bind_button3 $ui_comm "tk_popup $ui_comm.ctxm %X %Y"
+bind_button3 $ui_comm "tk_popup $ctxm %X %Y"
# -- Diff Header
-set ui_fname_value {}
-set ui_fstatus_value {}
+#
+set current_diff {}
+set diff_actions [list]
+proc trace_current_diff {varname args} {
+ global current_diff diff_actions file_states
+ if {$current_diff eq {}} {
+ set s {}
+ set f {}
+ set p {}
+ set o disabled
+ } else {
+ set p $current_diff
+ set s [mapdesc [lindex $file_states($p) 0] $p]
+ set f {File:}
+ set p [escape_path $p]
+ set o normal
+ }
+
+ .vpane.lower.diff.header.status configure -text $s
+ .vpane.lower.diff.header.file configure -text $f
+ .vpane.lower.diff.header.path configure -text $p
+ foreach w $diff_actions {
+ uplevel #0 $w $o
+ }
+}
+trace add variable current_diff write trace_current_diff
+
frame .vpane.lower.diff.header -background orange
-label .vpane.lower.diff.header.l4 \
- -textvariable ui_fstatus_value \
+label .vpane.lower.diff.header.status \
-background orange \
-width $max_status_desc \
-anchor w \
-justify left \
-font font_ui
-label .vpane.lower.diff.header.l1 -text {File:} \
+label .vpane.lower.diff.header.file \
-background orange \
+ -anchor w \
+ -justify left \
-font font_ui
-set ui_fname .vpane.lower.diff.header.l2
-label $ui_fname \
- -textvariable ui_fname_value \
+label .vpane.lower.diff.header.path \
-background orange \
-anchor w \
-justify left \
-font font_ui
-menu $ui_fname.ctxm -tearoff 0
-$ui_fname.ctxm add command -label "Copy" \
+pack .vpane.lower.diff.header.status -side left
+pack .vpane.lower.diff.header.file -side left
+pack .vpane.lower.diff.header.path -fill x
+set ctxm .vpane.lower.diff.header.ctxm
+menu $ctxm -tearoff 0
+$ctxm add command \
+ -label {Copy} \
-font font_ui \
-command {
clipboard clear
clipboard append \
-format STRING \
-type STRING \
- -- $ui_fname_value
+ -- $current_diff
}
-bind_button3 $ui_fname "tk_popup $ui_fname.ctxm %X %Y"
-pack .vpane.lower.diff.header.l4 -side left
-pack .vpane.lower.diff.header.l1 -side left
-pack $ui_fname -fill x
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+bind_button3 .vpane.lower.diff.header.path "tk_popup $ctxm %X %Y"
# -- Diff Body
+#
frame .vpane.lower.diff.body
set ui_diff .vpane.lower.diff.body.t
text $ui_diff -background white -borderwidth 0 \
# -- Diff Body Context Menu
#
-menu $ui_diff.ctxm -tearoff 0
-$ui_diff.ctxm add command -label "Copy" \
+set ctxm .vpane.lower.diff.body.ctxm
+menu $ctxm -tearoff 0
+$ctxm add command \
+ -label {Copy} \
-font font_ui \
- -command "tk_textCopy $ui_diff"
-$ui_diff.ctxm add command -label "Select All" \
+ -command {tk_textCopy $ui_diff}
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add command \
+ -label {Select All} \
-font font_ui \
- -command "$ui_diff tag add sel 0.0 end"
-$ui_diff.ctxm add command -label "Copy All" \
+ -command {$ui_diff tag add sel 0.0 end}
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add command \
+ -label {Copy All} \
-font font_ui \
- -command "
+ -command {
$ui_diff tag add sel 0.0 end
tk_textCopy $ui_diff
$ui_diff tag remove sel 0.0 end
- "
-$ui_diff.ctxm add separator
-$ui_diff.ctxm add command -label "Decrease Font Size" \
+ }
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add separator
+$ctxm add command \
+ -label {Decrease Font Size} \
-font font_ui \
-command {incr_font_size font_diff -1}
-$ui_diff.ctxm add command -label "Increase Font Size" \
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add command \
+ -label {Increase Font Size} \
-font font_ui \
-command {incr_font_size font_diff 1}
-$ui_diff.ctxm add separator
-$ui_diff.ctxm add command -label "Show Less Context" \
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add separator
+$ctxm add command \
+ -label {Show Less Context} \
-font font_ui \
- -command {if {$ui_fname_value ne {}
- && $repo_config(gui.diffcontext) >= 2} {
+ -command {if {$repo_config(gui.diffcontext) >= 2} {
incr repo_config(gui.diffcontext) -1
reshow_diff
}}
-$ui_diff.ctxm add command -label "Show More Context" \
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add command \
+ -label {Show More Context} \
-font font_ui \
- -command {if {$ui_fname_value ne {}} {
+ -command {
incr repo_config(gui.diffcontext)
reshow_diff
- }}
-$ui_diff.ctxm add separator
-$ui_diff.ctxm add command -label {Options...} \
+ }
+lappend diff_actions [list $ctxm entryconf [$ctxm index last] -state]
+$ctxm add separator
+$ctxm add command -label {Options...} \
-font font_ui \
-command do_options
-bind_button3 $ui_diff "tk_popup $ui_diff.ctxm %X %Y"
+bind_button3 $ui_diff "tk_popup $ctxm %X %Y"
# -- Status Bar
+#
set ui_status_value {Initializing...}
label .status -textvariable ui_status_value \
-anchor w \
pack .status -anchor w -side bottom -fill x
# -- Load geometry
+#
catch {
set gm $repo_config(gui.geometry)
wm geometry . [lindex $gm 0]
}
# -- Key Bindings
+#
bind $ui_comm <$M1B-Key-Return> {do_commit;break}
bind $ui_comm <$M1B-Key-i> {do_include_all;break}
bind $ui_comm <$M1B-Key-I> {do_include_all;break}
set file_lists($ui_index) [list]
set file_lists($ui_other) [list]
+set HEAD {}
+set PARENT {}
+set commit_type {}
+set empty_tree {}
+set current_diff {}
+set selected_commit_type new
+
wm title . "$appname ([file normalize [file dirname $gitdir]])"
focus -force $ui_comm
if {!$single_commit} {
load_all_remotes
- populate_remote_menu .mbar.fetch From fetch_from
- populate_remote_menu .mbar.push To push_to
+ populate_fetch_menu .mbar.fetch
populate_pull_menu .mbar.pull
+ populate_push_menu .mbar.push
}
-after 1 rescan
+lock_index begin-read
+after 1 do_rescan